diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/spectrum/model/wifi-spectrum-value-helper.h ns-3.39/src/spectrum/model/wifi-spectrum-value-helper.h
--- ns-3.38/src/spectrum/model/wifi-spectrum-value-helper.h	2023-03-16 20:54:23.828869000 -0700
+++ ns-3.39/src/spectrum/model/wifi-spectrum-value-helper.h	2023-07-05 14:23:48.081428300 -0700
@@ -28,9 +28,9 @@
 {
 
 /**
- * typedef for a pair of start and stop sub-band indexes
+ * typedef for a pair of start and stop sub-band indices
  */
-typedef std::pair<uint32_t, uint32_t> WifiSpectrumBand;
+using WifiSpectrumBandIndices = std::pair<uint32_t, uint32_t>;
 
 /**
  * \ingroup spectrum
@@ -45,7 +45,7 @@
     /**
      * Destructor
      */
-    virtual ~WifiSpectrumValueHelper();
+    virtual ~WifiSpectrumValueHelper() = default;
 
     /**
      * Return a SpectrumModel instance corresponding to the center frequency
@@ -55,7 +55,7 @@
      *
      * \param centerFrequency center frequency (MHz)
      * \param channelWidth channel width (MHz)
-     * \param bandBandwidth width of each band (Hz)
+     * \param carrierSpacing carrier spacing (Hz)
      * \param guardBandwidth width of the guard band (MHz)
      *
      * \return the static SpectrumModel instance corresponding to the
@@ -63,7 +63,7 @@
      */
     static Ptr<SpectrumModel> GetSpectrumModel(uint32_t centerFrequency,
                                                uint16_t channelWidth,
-                                               uint32_t bandBandwidth,
+                                               uint32_t carrierSpacing,
                                                uint16_t guardBandwidth);
 
     /**
@@ -198,18 +198,19 @@
      * \return a pointer to a newly allocated SpectrumValue representing the HE OFDM Transmit Power
      * Spectral Density on the RU used by the STA in W/Hz for each Band
      */
-    static Ptr<SpectrumValue> CreateHeMuOfdmTxPowerSpectralDensity(uint32_t centerFrequency,
-                                                                   uint16_t channelWidth,
-                                                                   double txPowerW,
-                                                                   uint16_t guardBandwidth,
-                                                                   WifiSpectrumBand ru);
+    static Ptr<SpectrumValue> CreateHeMuOfdmTxPowerSpectralDensity(
+        uint32_t centerFrequency,
+        uint16_t channelWidth,
+        double txPowerW,
+        uint16_t guardBandwidth,
+        const WifiSpectrumBandIndices& ru);
 
     /**
      * Create a power spectral density corresponding to the noise
      *
      * \param centerFrequency center frequency (MHz)
      * \param channelWidth channel width (MHz)
-     * \param bandBandwidth width of each band (Hz)
+     * \param carrierSpacing carrier spacing (Hz)
      * \param noiseFigure the noise figure in dB w.r.t. a reference temperature of 290K
      * \param guardBandwidth width of the guard band (MHz)
      * \return a pointer to a newly allocated SpectrumValue representing the noise Power Spectral
@@ -217,7 +218,7 @@
      */
     static Ptr<SpectrumValue> CreateNoisePowerSpectralDensity(uint32_t centerFrequency,
                                                               uint16_t channelWidth,
-                                                              uint32_t bandBandwidth,
+                                                              uint32_t carrierSpacing,
                                                               double noiseFigure,
                                                               uint16_t guardBandwidth);
 
@@ -233,24 +234,6 @@
                                                               Ptr<SpectrumModel> spectrumModel);
 
     /**
-     * Create a spectral density corresponding to the RF filter
-     *
-     * \param centerFrequency the center frequency (MHz)
-     * \param totalChannelWidth the total channel width (MHz)
-     * \param bandBandwidth the width of each band (MHz)
-     * \param guardBandwidth the width of the guard band (MHz)
-     * \param band the pair of start and stop indexes that defines the band to be filtered
-     *
-     * \return a pointer to a SpectrumValue representing the RF filter applied
-     * to an received power spectral density
-     */
-    static Ptr<SpectrumValue> CreateRfFilter(uint32_t centerFrequency,
-                                             uint16_t totalChannelWidth,
-                                             uint32_t bandBandwidth,
-                                             uint16_t guardBandwidth,
-                                             WifiSpectrumBand band);
-
-    /**
      * Create a transmit power spectral density corresponding to OFDM
      * transmit spectrum mask requirements for 11a/11g/11n/11ac/11ax
      * Channel width may vary between 5, 10, 20, 40, 80, and 160 MHz.
@@ -299,15 +282,16 @@
      */
     static void CreateSpectrumMaskForOfdm(
         Ptr<SpectrumValue> c,
-        const std::vector<WifiSpectrumBand>& allocatedSubBands,
-        WifiSpectrumBand maskBand,
+        const std::vector<WifiSpectrumBandIndices>& allocatedSubBands,
+        const WifiSpectrumBandIndices& maskBand,
         double txPowerPerBandW,
         uint32_t nGuardBands,
         uint32_t innerSlopeWidth,
         double minInnerBandDbr,
         double minOuterbandDbr,
         double lowestPointDbr,
-        const std::vector<WifiSpectrumBand>& puncturedSubBands = std::vector<WifiSpectrumBand>{},
+        const std::vector<WifiSpectrumBandIndices>& puncturedSubBands =
+            std::vector<WifiSpectrumBandIndices>{},
         uint32_t puncturedSlopeWidth = 0);
 
     /**
@@ -338,63 +322,73 @@
      *
      * \return band power in W
      */
-    static double GetBandPowerW(Ptr<SpectrumValue> psd, const WifiSpectrumBand& band);
+    static double GetBandPowerW(Ptr<SpectrumValue> psd, const WifiSpectrumBandIndices& band);
 };
 
 /**
  * \ingroup spectrum
- *
- * Implements Wifi SpectrumValue for the 2.4 GHz ISM band only, with a
- * 5 MHz spectrum resolution.
- *
+ * Struct defining a frequency range between minFrequency (MHz) and maxFrequency (MHz).
  */
-class WifiSpectrumValue5MhzFactory
+struct FrequencyRange
 {
-  public:
-    /**
-     * Destructor
-     */
-    virtual ~WifiSpectrumValue5MhzFactory();
-    /**
-     * Creates a SpectrumValue instance with a constant value for all frequencies
-     *
-     * @param psd the constant value
-     *
-     * @return a Ptr to a newly created SpectrumValue
-     */
-    virtual Ptr<SpectrumValue> CreateConstant(double psd);
-    /**
-     * Creates a SpectrumValue instance that represents the TX Power Spectral
-     * Density  of a wifi device corresponding to the provided parameters
-     *
-     * Since the spectrum model has a resolution of 5 MHz, we model
-     * the transmitted signal with a constant density over a 20MHz
-     * bandwidth centered on the center frequency of the channel. The
-     * transmission power outside the transmission power density is
-     * calculated considering the transmit spectrum mask, see IEEE
-     * Std. 802.11-2007, Annex I.  The two bands just outside of the main
-     * 20 MHz are allocated power at -28 dB down from the center 20 MHz,
-     * and the two bands outside of this are allocated power at -40 dB down
-     * (with a total bandwidth of 60 MHz containing non-zero power allocation).
-     *
-     * @param txPower the total TX power in W
-     * @param channel the number of the channel (1 <= channel <= 13)
-     *
-     * @return a Ptr to a newly created SpectrumValue
-     */
-    virtual Ptr<SpectrumValue> CreateTxPowerSpectralDensity(double txPower, uint8_t channel);
-    /**
-     * Creates a SpectrumValue instance which
-     * represents the frequency response of the RF filter which is used
-     * by a wifi device to receive signals when tuned to a particular channel
-     *
-     * @param channel the number of the channel (1 <= channel <= 13)
-     *
-     * @return a Ptr to a newly created SpectrumValue
-     */
-    virtual Ptr<SpectrumValue> CreateRfFilter(uint8_t channel);
+    uint16_t minFrequency{0}; ///< the minimum frequency in MHz
+    uint16_t maxFrequency{0}; ///< the maximum frequency in MHz
 };
 
+/**
+ * Compare two FrequencyRange values
+ *
+ * \param lhs the FrequencyRange value on the left of operator
+ * \param rhs the FrequencyRange value on the right of operator
+ *
+ * \return true if minFrequency of left is less than minFrequency of right, false otherwise
+ */
+bool operator<(const FrequencyRange& lhs, const FrequencyRange& rhs);
+
+/**
+ * Compare two FrequencyRange values
+ *
+ * \param lhs the FrequencyRange value on the left of operator
+ * \param rhs the FrequencyRange value on the right of operator
+ *
+ * \return true if both minFrequency and maxFrequency of left are equal to minFrequency and
+ * maxFrequency of right respectively, false otherwise
+ */
+bool operator==(const FrequencyRange& lhs, const FrequencyRange& rhs);
+
+/**
+ * Compare two FrequencyRange values
+ *
+ * \param lhs the FrequencyRange value on the left of operator
+ * \param rhs the FrequencyRange value on the right of operator
+ *
+ * \return true if either minFrequency or maxFrequency of left different from minFrequency or
+ * maxFrequency of right respectively, false otherwise
+ */
+bool operator!=(const FrequencyRange& lhs, const FrequencyRange& rhs);
+
+/**
+ * Serialize FrequencyRange values to ostream (human-readable).
+ *
+ * \param os the output stream
+ * \param freqRange the FrequencyRange
+ *
+ * \return std::ostream
+ */
+std::ostream& operator<<(std::ostream& os, const FrequencyRange& freqRange);
+
+/// Identifier for the frequency range covering the whole wifi spectrum
+constexpr FrequencyRange WHOLE_WIFI_SPECTRUM = {2401, 7125};
+
+/// Identifier for the frequency range covering the wifi spectrum in the 2.4 GHz band
+constexpr FrequencyRange WIFI_SPECTRUM_2_4_GHZ = {2401, 2483};
+
+/// Identifier for the frequency range covering the wifi spectrum in the 5 GHz band
+constexpr FrequencyRange WIFI_SPECTRUM_5_GHZ = {5170, 5915};
+
+/// Identifier for the frequency range covering the wifi spectrum in the 6 GHz band
+constexpr FrequencyRange WIFI_SPECTRUM_6_GHZ = {5945, 7125};
+
 } // namespace ns3
 
 #endif /*  WIFI_SPECTRUM_VALUE_HELPER_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/spectrum/test/examples-to-run.py ns-3.39/src/spectrum/test/examples-to-run.py
--- ns-3.38/src/spectrum/test/examples-to-run.py	2023-03-16 20:54:23.828869000 -0700
+++ ns-3.39/src/spectrum/test/examples-to-run.py	2023-07-05 14:23:48.081428300 -0700
@@ -1,5 +1,4 @@
 #! /usr/bin/env python3
-## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
 
 # A list of C++ examples to run in order to ensure that they remain
 # buildable and runnable over time.  Each tuple in the list contains
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/spectrum/test/spectrum-ideal-phy-test.cc ns-3.39/src/spectrum/test/spectrum-ideal-phy-test.cc
--- ns-3.38/src/spectrum/test/spectrum-ideal-phy-test.cc	2023-03-16 20:54:23.828869000 -0700
+++ ns-3.39/src/spectrum/test/spectrum-ideal-phy-test.cc	2023-07-05 14:23:48.081428300 -0700
@@ -21,6 +21,7 @@
 #include <ns3/config.h>
 #include <ns3/data-rate.h>
 #include <ns3/friis-spectrum-propagation-loss.h>
+#include <ns3/ism-spectrum-value-helper.h>
 #include <ns3/log.h>
 #include <ns3/math.h>
 #include <ns3/mobility-helper.h>
@@ -43,7 +44,6 @@
 #include <ns3/test.h>
 #include <ns3/uinteger.h>
 #include <ns3/waveform-generator.h>
-#include <ns3/wifi-spectrum-value-helper.h>
 
 #include <iomanip>
 #include <iostream>
@@ -170,7 +170,7 @@
     channelHelper.AddPropagationLoss(propLoss);
     Ptr<SpectrumChannel> channel = channelHelper.Create();
 
-    WifiSpectrumValue5MhzFactory sf;
+    SpectrumValue5MhzFactory sf;
 
     uint32_t channelNumber = 1;
     Ptr<SpectrumValue> txPsd = sf.CreateTxPowerSpectralDensity(txPowerW, channelNumber);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/spectrum/test/spectrum-interference-test.cc ns-3.39/src/spectrum/test/spectrum-interference-test.cc
--- ns-3.38/src/spectrum/test/spectrum-interference-test.cc	2023-03-16 20:54:23.828869000 -0700
+++ ns-3.39/src/spectrum/test/spectrum-interference-test.cc	2023-07-05 14:23:48.081428300 -0700
@@ -62,7 +62,7 @@
   private:
     Ptr<SpectrumValue> m_s;                     //!< Spectrum value
     uint32_t m_txBytes;                         //!< number of bytes to transmit
-    uint32_t m_rxCorrectKnownOutcome;           //!< extected Rx bytes
+    uint32_t m_rxCorrectKnownOutcome;           //!< expected Rx bytes
     Ptr<const SpectrumModel> m_mySpectrumModel; //!< Spectrum model pointer
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/spectrum/test/spectrum-test.h ns-3.39/src/spectrum/test/spectrum-test.h
--- ns-3.38/src/spectrum/test/spectrum-test.h	2023-03-16 20:54:23.828869000 -0700
+++ ns-3.39/src/spectrum/test/spectrum-test.h	2023-07-05 14:23:48.081428300 -0700
@@ -19,6 +19,9 @@
  * part of the code copied from test.h
  */
 
+#ifndef SPECTRUM_TEST_H
+#define SPECTRUM_TEST_H
+
 #include <ns3/spectrum-value.h>
 #include <ns3/test.h>
 
@@ -155,3 +158,5 @@
                               (__LINE__));                                                         \
         }                                                                                          \
     } while (false);
+
+#endif // SPECTRUM_TEST_H
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/spectrum/test/three-gpp-channel-test-suite.cc ns-3.39/src/spectrum/test/three-gpp-channel-test-suite.cc
--- ns-3.38/src/spectrum/test/three-gpp-channel-test-suite.cc	2023-03-16 20:54:23.828869000 -0700
+++ ns-3.39/src/spectrum/test/three-gpp-channel-test-suite.cc	2023-07-05 14:23:48.081428300 -0700
@@ -21,6 +21,7 @@
 #include "ns3/config.h"
 #include "ns3/constant-position-mobility-model.h"
 #include "ns3/double.h"
+#include "ns3/ism-spectrum-value-helper.h"
 #include "ns3/isotropic-antenna-model.h"
 #include "ns3/log.h"
 #include "ns3/node-container.h"
@@ -34,7 +35,6 @@
 #include "ns3/three-gpp-spectrum-propagation-loss-model.h"
 #include "ns3/uinteger.h"
 #include "ns3/uniform-planar-array.h"
-#include "ns3/wifi-spectrum-value-helper.h"
 
 using namespace ns3;
 
@@ -636,7 +636,7 @@
     DoBeamforming(rxDev, rxAntenna, txDev, txAntenna);
 
     // create the tx psd
-    WifiSpectrumValue5MhzFactory sf;
+    SpectrumValue5MhzFactory sf;
     double txPower = 0.1; // Watts
     uint32_t channelNumber = 1;
     Ptr<SpectrumValue> txPsd = sf.CreateTxPowerSpectralDensity(txPower, channelNumber);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/stats/helper/file-helper.cc ns-3.39/src/stats/helper/file-helper.cc
--- ns-3.38/src/stats/helper/file-helper.cc	2023-03-16 20:54:23.828869000 -0700
+++ ns-3.39/src/stats/helper/file-helper.cc	2023-07-05 14:23:48.085428200 -0700
@@ -47,7 +47,7 @@
 }
 
 FileHelper::FileHelper(const std::string& outputFileNameWithoutExtension,
-                       enum FileAggregator::FileType fileType)
+                       FileAggregator::FileType fileType)
     : m_aggregator(nullptr),
       m_fileProbeCount(0),
       m_fileType(fileType),
@@ -67,7 +67,7 @@
 
 void
 FileHelper::ConfigureFile(const std::string& outputFileNameWithoutExtension,
-                          enum FileAggregator::FileType fileType)
+                          FileAggregator::FileType fileType)
 {
     NS_LOG_FUNCTION(this << outputFileNameWithoutExtension << fileType);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/stats/helper/file-helper.h ns-3.39/src/stats/helper/file-helper.h
--- ns-3.38/src/stats/helper/file-helper.h	2023-03-16 20:54:23.828869000 -0700
+++ ns-3.39/src/stats/helper/file-helper.h	2023-07-05 14:23:48.085428200 -0700
@@ -56,7 +56,7 @@
      * specified by fileType.  The default file type is space-separated.
      */
     FileHelper(const std::string& outputFileNameWithoutExtension,
-               enum FileAggregator::FileType fileType = FileAggregator::SPACE_SEPARATED);
+               FileAggregator::FileType fileType = FileAggregator::SPACE_SEPARATED);
 
     virtual ~FileHelper();
 
@@ -72,7 +72,7 @@
      * is space-separated.
      */
     void ConfigureFile(const std::string& outputFileNameWithoutExtension,
-                       enum FileAggregator::FileType fileType = FileAggregator::SPACE_SEPARATED);
+                       FileAggregator::FileType fileType = FileAggregator::SPACE_SEPARATED);
 
     /**
      * \param typeId the type ID for the probe used when it is created.
@@ -298,7 +298,7 @@
     uint32_t m_fileProbeCount;
 
     /// Determines the kind of file written by the aggregator.
-    enum FileAggregator::FileType m_fileType;
+    FileAggregator::FileType m_fileType;
 
     /// The name of the output file to created without its extension.
     std::string m_outputFileNameWithoutExtension;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/stats/helper/gnuplot-helper.cc ns-3.39/src/stats/helper/gnuplot-helper.cc
--- ns-3.38/src/stats/helper/gnuplot-helper.cc	2023-03-16 20:54:23.828869000 -0700
+++ ns-3.39/src/stats/helper/gnuplot-helper.cc	2023-07-05 14:23:48.085428200 -0700
@@ -107,7 +107,7 @@
                          const std::string& path,
                          const std::string& probeTraceSource,
                          const std::string& title,
-                         enum GnuplotAggregator::KeyLocation keyLocation)
+                         GnuplotAggregator::KeyLocation keyLocation)
 {
     NS_LOG_FUNCTION(this << typeId << path << probeTraceSource << title << keyLocation);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/stats/helper/gnuplot-helper.h ns-3.39/src/stats/helper/gnuplot-helper.h
--- ns-3.38/src/stats/helper/gnuplot-helper.h	2023-03-16 20:54:23.828869000 -0700
+++ ns-3.39/src/stats/helper/gnuplot-helper.h	2023-07-05 14:23:48.085428200 -0700
@@ -124,7 +124,7 @@
                    const std::string& path,
                    const std::string& probeTraceSource,
                    const std::string& title,
-                   enum GnuplotAggregator::KeyLocation keyLocation = GnuplotAggregator::KEY_INSIDE);
+                   GnuplotAggregator::KeyLocation keyLocation = GnuplotAggregator::KEY_INSIDE);
 
     /**
      * \param adaptorName the timeSeriesAdaptor's name.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/stats/model/get-wildcard-matches.cc ns-3.39/src/stats/model/get-wildcard-matches.cc
--- ns-3.38/src/stats/model/get-wildcard-matches.cc	2023-03-16 20:54:23.828869000 -0700
+++ ns-3.39/src/stats/model/get-wildcard-matches.cc	2023-07-05 14:23:48.085428200 -0700
@@ -79,7 +79,7 @@
     tokenStart = 0;
     for (i = 0; i < nonWildcardTokenCount; i++)
     {
-        // Look for the non-wilcard token.
+        // Look for the non-wildcard token.
         token = matchedPath.find(nonWildcardTokens[i], tokenStart);
 
         // Make sure that the token is found.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/stats/model/gnuplot-aggregator.cc ns-3.39/src/stats/model/gnuplot-aggregator.cc
--- ns-3.38/src/stats/model/gnuplot-aggregator.cc	2023-03-16 20:54:23.828869000 -0700
+++ ns-3.39/src/stats/model/gnuplot-aggregator.cc	2023-07-05 14:23:48.085428200 -0700
@@ -274,14 +274,14 @@
 }
 
 void
-GnuplotAggregator::Set2dDatasetDefaultStyle(enum Gnuplot2dDataset::Style style)
+GnuplotAggregator::Set2dDatasetDefaultStyle(Gnuplot2dDataset::Style style)
 {
     NS_LOG_FUNCTION(style);
     Gnuplot2dDataset::SetDefaultStyle(style);
 }
 
 void
-GnuplotAggregator::Set2dDatasetStyle(const std::string& dataset, enum Gnuplot2dDataset::Style style)
+GnuplotAggregator::Set2dDatasetStyle(const std::string& dataset, Gnuplot2dDataset::Style style)
 {
     NS_LOG_FUNCTION(this << dataset << style);
     if (m_2dDatasetMap.count(dataset) == 0)
@@ -294,7 +294,7 @@
 }
 
 void
-GnuplotAggregator::Set2dDatasetDefaultErrorBars(enum Gnuplot2dDataset::ErrorBars errorBars)
+GnuplotAggregator::Set2dDatasetDefaultErrorBars(Gnuplot2dDataset::ErrorBars errorBars)
 {
     NS_LOG_FUNCTION(errorBars);
     Gnuplot2dDataset::SetDefaultErrorBars(errorBars);
@@ -302,7 +302,7 @@
 
 void
 GnuplotAggregator::Set2dDatasetErrorBars(const std::string& dataset,
-                                         enum Gnuplot2dDataset::ErrorBars errorBars)
+                                         Gnuplot2dDataset::ErrorBars errorBars)
 {
     NS_LOG_FUNCTION(this << dataset << errorBars);
     if (m_2dDatasetMap.count(dataset) == 0)
@@ -315,7 +315,7 @@
 }
 
 void
-GnuplotAggregator::SetKeyLocation(enum GnuplotAggregator::KeyLocation keyLocation)
+GnuplotAggregator::SetKeyLocation(GnuplotAggregator::KeyLocation keyLocation)
 {
     NS_LOG_FUNCTION(this << keyLocation);
     // Set the specified key location.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/stats/model/gnuplot-aggregator.h ns-3.39/src/stats/model/gnuplot-aggregator.h
--- ns-3.38/src/stats/model/gnuplot-aggregator.h	2023-03-16 20:54:23.828869000 -0700
+++ ns-3.39/src/stats/model/gnuplot-aggregator.h	2023-07-05 14:23:48.085428200 -0700
@@ -210,7 +210,7 @@
      *
      * \brief Change default style for all newly created objects.
      */
-    static void Set2dDatasetDefaultStyle(enum Gnuplot2dDataset::Style style);
+    static void Set2dDatasetDefaultStyle(Gnuplot2dDataset::Style style);
 
     /**
      * \param dataset the gnuplot 2D dataset to be plotted.
@@ -221,14 +221,14 @@
      * The string in dataset should match the context for the Collector
      * it is connected to.
      */
-    void Set2dDatasetStyle(const std::string& dataset, enum Gnuplot2dDataset::Style style);
+    void Set2dDatasetStyle(const std::string& dataset, Gnuplot2dDataset::Style style);
 
     /**
      * \param errorBars the style of errorbars to use for newly created datasets.
      *
      * \brief Change default errorbars style for all newly created objects.
      */
-    static void Set2dDatasetDefaultErrorBars(enum Gnuplot2dDataset::ErrorBars errorBars);
+    static void Set2dDatasetDefaultErrorBars(Gnuplot2dDataset::ErrorBars errorBars);
 
     /**
      * \param dataset the gnuplot 2D dataset to be plotted.
@@ -244,8 +244,7 @@
      * The string in dataset should match the context for the Collector
      * it is connected to.
      */
-    void Set2dDatasetErrorBars(const std::string& dataset,
-                               enum Gnuplot2dDataset::ErrorBars errorBars);
+    void Set2dDatasetErrorBars(const std::string& dataset, Gnuplot2dDataset::ErrorBars errorBars);
 
     /**
      * \param keyLocation the location of the key in the plot.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/stats/model/gnuplot.cc ns-3.39/src/stats/model/gnuplot.cc
--- ns-3.38/src/stats/model/gnuplot.cc	2023-03-16 20:54:23.828869000 -0700
+++ ns-3.39/src/stats/model/gnuplot.cc	2023-07-05 14:23:48.085428200 -0700
@@ -109,7 +109,7 @@
 
 std::string GnuplotDataset::m_defaultExtra = "";
 
-GnuplotDataset::GnuplotDataset(struct Data* data)
+GnuplotDataset::GnuplotDataset(Data* data)
     : m_data(data)
 {
 }
@@ -340,9 +340,9 @@
 // --- Gnuplot2dDataset ---------------------------------------------------- //
 
 /// Default plot style static instance
-enum Gnuplot2dDataset::Style Gnuplot2dDataset::m_defaultStyle = LINES;
+Gnuplot2dDataset::Style Gnuplot2dDataset::m_defaultStyle = LINES;
 /// Default error bars type static instance
-enum Gnuplot2dDataset::ErrorBars Gnuplot2dDataset::m_defaultErrorBars = NONE;
+Gnuplot2dDataset::ErrorBars Gnuplot2dDataset::m_defaultErrorBars = NONE;
 
 Gnuplot2dDataset::Gnuplot2dDataset(const std::string& title)
     : GnuplotDataset(new Data2d(title))
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/stats/model/gnuplot.h ns-3.39/src/stats/model/gnuplot.h
--- ns-3.38/src/stats/model/gnuplot.h	2023-03-16 20:54:23.828869000 -0700
+++ ns-3.39/src/stats/model/gnuplot.h	2023-07-05 14:23:48.085428200 -0700
@@ -97,12 +97,12 @@
      * Called by constructors of derived classes.
      * \param data the reference counted data object representing this dataset.
      */
-    GnuplotDataset(struct Data* data);
+    GnuplotDataset(Data* data);
 
     /**
      * Reference counted data object.
      */
-    struct Data* m_data;
+    Data* m_data;
 };
 
 /**
@@ -223,7 +223,7 @@
     };
 
     /// The set of points in the dataset
-    typedef std::vector<struct Point> PointSet;
+    typedef std::vector<Point> PointSet;
 
     static Style m_defaultStyle;         //!< default plot style
     static ErrorBars m_defaultErrorBars; //!< default error bars type
@@ -318,7 +318,7 @@
     };
 
     /// The set of points in the dataset
-    typedef std::vector<struct Point> PointSet;
+    typedef std::vector<Point> PointSet;
 
     static std::string m_defaultStyle; //!< default plot style
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/stats/model/histogram.cc ns-3.39/src/stats/model/histogram.cc
--- ns-3.38/src/stats/model/histogram.cc	2023-03-16 20:54:23.828869000 -0700
+++ ns-3.39/src/stats/model/histogram.cc	2023-07-05 14:23:48.085428200 -0700
@@ -71,7 +71,7 @@
 }
 
 uint32_t
-Histogram::GetBinCount(uint32_t index)
+Histogram::GetBinCount(uint32_t index) const
 {
     NS_ASSERT(index < m_histogram.size());
     return m_histogram[index];
@@ -92,6 +92,12 @@
     m_histogram[index]++;
 }
 
+void
+Histogram::Clear()
+{
+    m_histogram.clear();
+}
+
 Histogram::Histogram(double binWidth)
 {
     m_binWidth = binWidth;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/stats/model/histogram.h ns-3.39/src/stats/model/histogram.h
--- ns-3.38/src/stats/model/histogram.h	2023-03-16 20:54:23.828869000 -0700
+++ ns-3.39/src/stats/model/histogram.h	2023-07-05 14:23:48.085428200 -0700
@@ -93,7 +93,7 @@
      * \param index the bin index
      * \return the number of data added to the bin
      */
-    uint32_t GetBinCount(uint32_t index);
+    uint32_t GetBinCount(uint32_t index) const;
 
     // Method for adding values
     /**
@@ -103,6 +103,11 @@
     void AddValue(double value);
 
     /**
+     * Clear the histogram content.
+     */
+    void Clear();
+
+    /**
      * \brief Serializes the results to an std::ostream in XML format.
      * \param os the output stream
      * \param indent number of spaces to use as base indentation level
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/stats/model/sqlite-output.cc ns-3.39/src/stats/model/sqlite-output.cc
--- ns-3.38/src/stats/model/sqlite-output.cc	2023-03-16 20:54:23.832869300 -0700
+++ ns-3.39/src/stats/model/sqlite-output.cc	2023-07-05 14:23:48.085428200 -0700
@@ -132,11 +132,7 @@
 bool
 SQLiteOutput::Bind(sqlite3_stmt* stmt, int pos, const Time& value) const
 {
-    if (sqlite3_bind_double(stmt, pos, value.GetSeconds()) == SQLITE_OK)
-    {
-        return true;
-    }
-    return false;
+    return sqlite3_bind_double(stmt, pos, value.GetSeconds()) == SQLITE_OK;
 }
 
 //! \copydoc SQLiteOutput::Bind
@@ -144,11 +140,7 @@
 bool
 SQLiteOutput::Bind(sqlite3_stmt* stmt, int pos, const double& value) const
 {
-    if (sqlite3_bind_double(stmt, pos, value) == SQLITE_OK)
-    {
-        return true;
-    }
-    return false;
+    return sqlite3_bind_double(stmt, pos, value) == SQLITE_OK;
 }
 
 //! \copydoc SQLiteOutput::Bind
@@ -156,11 +148,7 @@
 bool
 SQLiteOutput::Bind(sqlite3_stmt* stmt, int pos, const uint32_t& value) const
 {
-    if (sqlite3_bind_int(stmt, pos, static_cast<int>(value)) == SQLITE_OK)
-    {
-        return true;
-    }
-    return false;
+    return sqlite3_bind_int(stmt, pos, static_cast<int>(value)) == SQLITE_OK;
 }
 
 //! \copydoc SQLiteOutput::Bind
@@ -168,11 +156,7 @@
 bool
 SQLiteOutput::Bind(sqlite3_stmt* stmt, int pos, const long& value) const
 {
-    if (sqlite3_bind_int64(stmt, pos, value) == SQLITE_OK)
-    {
-        return true;
-    }
-    return false;
+    return sqlite3_bind_int64(stmt, pos, value) == SQLITE_OK;
 }
 
 //! \copydoc SQLiteOutput::Bind
@@ -180,11 +164,7 @@
 bool
 SQLiteOutput::Bind(sqlite3_stmt* stmt, int pos, const long long& value) const
 {
-    if (sqlite3_bind_int64(stmt, pos, value) == SQLITE_OK)
-    {
-        return true;
-    }
-    return false;
+    return sqlite3_bind_int64(stmt, pos, value) == SQLITE_OK;
 }
 
 //! \copydoc SQLiteOutput::Bind
@@ -192,11 +172,7 @@
 bool
 SQLiteOutput::Bind(sqlite3_stmt* stmt, int pos, const uint16_t& value) const
 {
-    if (sqlite3_bind_int(stmt, pos, static_cast<int>(value)) == SQLITE_OK)
-    {
-        return true;
-    }
-    return false;
+    return sqlite3_bind_int(stmt, pos, static_cast<int>(value)) == SQLITE_OK;
 }
 
 //! \copydoc SQLiteOutput::Bind
@@ -204,11 +180,7 @@
 bool
 SQLiteOutput::Bind(sqlite3_stmt* stmt, int pos, const uint8_t& value) const
 {
-    if (sqlite3_bind_int(stmt, pos, static_cast<int>(value)) == SQLITE_OK)
-    {
-        return true;
-    }
-    return false;
+    return sqlite3_bind_int(stmt, pos, static_cast<int>(value)) == SQLITE_OK;
 }
 
 //! \copydoc SQLiteOutput::Bind
@@ -216,11 +188,7 @@
 bool
 SQLiteOutput::Bind(sqlite3_stmt* stmt, int pos, const int& value) const
 {
-    if (sqlite3_bind_int(stmt, pos, value) == SQLITE_OK)
-    {
-        return true;
-    }
-    return false;
+    return sqlite3_bind_int(stmt, pos, value) == SQLITE_OK;
 }
 
 //! \copydoc SQLiteOutput::Bind
@@ -228,11 +196,7 @@
 bool
 SQLiteOutput::Bind(sqlite3_stmt* stmt, int pos, const std::string& value) const
 {
-    if (sqlite3_bind_text(stmt, pos, value.c_str(), -1, SQLITE_STATIC) == SQLITE_OK)
-    {
-        return true;
-    }
-    return false;
+    return sqlite3_bind_text(stmt, pos, value.c_str(), -1, SQLITE_STATIC) == SQLITE_OK;
 }
 
 int
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/stats/test/examples-to-run.py ns-3.39/src/stats/test/examples-to-run.py
--- ns-3.38/src/stats/test/examples-to-run.py	2023-03-16 20:54:23.832869300 -0700
+++ ns-3.39/src/stats/test/examples-to-run.py	2023-07-05 14:23:48.085428200 -0700
@@ -1,5 +1,4 @@
 #! /usr/bin/env python3
-## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
 
 # A list of C++ examples to run in order to ensure that they remain
 # buildable and runnable over time.  Each tuple in the list contains
